class MFInventoryItem : Thinker abstract {

    virtual clearscope String myTexture() { return "SOULA0"; }
    virtual clearscope String myName() { return ""; }
    virtual virtualscope bool use() { return true; }

    MFInventoryItem Init(void) {
        ChangeStatNum(STAT_STATIC);
        return self;
    }
    
    clearscope String getName() { return myName(); }
    
    clearscope TextureID getTexture() {
        return TexMan.CheckForTexture(myTexture(), TexMan.Type_Sprite);
    }
    
}

class MFIEmpty : MFInventoryItem {
    override String myTexture() { return ""; }
    override String myName() { return ""; }
}

class MFIMegasphere : MFInventoryItem {
    override String myTexture() { return "MEGAA0"; }
    override String myName() { return "Megasphere"; }
    override bool use() {
        PlayerPawn p; ThinkerIterator it = ThinkerIterator.Create("PlayerPawn"); p = PlayerPawn(it.Next());
        if (p.Health >= 200) {
            return false;
        }
        p.GiveInventory("MegasphereHealth", 1);
        return true;
    }
}

class MFIRadsuit : MFInventoryItem {
    override String myTexture() { return "SUITA0"; }
    override String myName() { return "Radsuit"; }
    override bool use() {
        return true;
    }
}

class MFIMedikit : MFInventoryItem {
    override String myTexture() { return "MEDIA0"; }
    override String myName() { return "Medikit"; }
    override bool use() {
        PlayerPawn p; ThinkerIterator it = ThinkerIterator.Create("PlayerPawn"); p = PlayerPawn(it.Next());
        if (p.Health >= 100) {
            return false;
        }
        p.GiveInventory("Health", 50);
        p.A_PlaySound("po/heal");
        return true;
    }
}

class MFIStimpack : MFInventoryItem {
    override String myTexture() { return "STIMA0"; }
    override String myName() { return "Stimpack"; }
    override bool use() {
        PlayerPawn p; ThinkerIterator it = ThinkerIterator.Create("PlayerPawn"); p = PlayerPawn(it.Next());
        if (p.Health >= 100) {
            return false;
        }
        p.GiveInventory("Health", 20);
        p.A_PlaySound("po/heal");
        return true;
    }
}

class MFIAmmoBox : MFInventoryItem {
    override String myTexture() { return "AMMOA0"; }
    override String myName() { return "Bullet Box"; }
    override bool use() {
        PlayerPawn p; ThinkerIterator it = ThinkerIterator.Create("PlayerPawn"); p = PlayerPawn(it.Next());
        p.GiveInventory("Clip", 25);
        p.A_PlaySound("po/reload");
        return true;
    }
}

class MFISoulsphere : MFInventoryItem {
    override String myTexture() { return "SOULA0"; }
    override String myName() { return "Soulsphere"; }
    override bool use() {
        PlayerPawn p; ThinkerIterator it = ThinkerIterator.Create("PlayerPawn"); p = PlayerPawn(it.Next());
        if (p.Health >= 200) {
            return false;
        }
        p.A_PlaySound("misc/p_pkup");
        p.GiveInventory("HealthBonus", 100);
        return true;
    }
}

///////////////////////

class POWeaponSlot : Thinker abstract {
    
    String weaponElement;
    
    virtual clearscope String myTexture() { return "WSLOTNUN"; }
    virtual clearscope String myType() { return "None"; }

    POWeaponSlot Init(void) {
        ChangeStatNum(STAT_STATIC);
        return self;
    }
    
    clearscope TextureID getTexture() {
        return TexMan.CheckForTexture(myTexture(), TexMan.Type_MiscPatch);
    }
    
    clearscope String getType() { return myType(); }
}

class POWeaponSlotEmpty : POWeaponSlot {
    override String myType() { return "None"; }
    override String myTexture() { return "WSLOTNUN"; }
}

class POWeaponSlotFist : POWeaponSlot {
    override String myType() { return "Fist"; }
    override String myTexture() { return "WSLOTFST"; }
}

class POWeaponSlotPistol : POWeaponSlot {
    override String myType() { return "Pistol"; }
    override String myTexture() { return "WSLOTPIS"; }
}

class POWeaponSlotShotgun : POWeaponSlot {
    override String myType() { return "Shotgun"; }
    override String myTexture() { return "WSLOTSHT"; }
}

class POWeaponSlotChaingun : POWeaponSlot {
    override String myType() { return "Chaingun"; }
    override String myTexture() { return "WSLOTCHN"; }
}

class POWeaponSlotLauncher : POWeaponSlot {
    override String myType() { return "RocketLauncher"; }
    override String myTexture() { return "WSLOTLAN"; }
}

class POWeaponSlotPlasma : POWeaponSlot {
    override String myType() { return "PlasmaRifle"; }
    override String myTexture() { return "WSLOTPLS"; }
}